diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/amove.s v15.6301-amd64/pop/src/amove.s
--- v15.63/pop/src/amove.s	1996-08-09 13:13:57.000000000 -0400
+++ v15.6301-amd64/pop/src/amove.s	2005-03-11 05:30:39.000000000 -0500
@@ -10,7 +10,7 @@
 #_INCLUDE 'declare.ph'
 
 lconstant macro	(
-	USP 		= "ebx",
+	USP 		= "rbx",
 );
 
 >_#
@@ -20,10 +20,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -47,14 +47,14 @@
 
 DEF_C_LAB (_bcmp)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	movl	8(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	movq	16(%USP), %rcx
+	addq	$16, %USP
 
 	;;; If size (ECX) is zero, then return <true> immediately
 
-	cmpl	$0, %ecx
+	cmpq	$0, %rcx
 	je	L1.1
 
 	;;; Clear the direction flag to increment ESI/EDI
@@ -70,12 +70,12 @@
 	;;; otherwise return <false>
 
 	je	L1.1
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
-L1.1:	movl	$C_LAB(true), (%USP)
+L1.1:	movq	$C_LAB(true), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _SCMP:
 ;;;	Compare two short (word) regions of the same length
@@ -90,15 +90,15 @@
 
 DEF_C_LAB (_scmp)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	movl	8(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	movq	16(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Convert ECX to size in words; if zero, then return <true>
 	;;; immediately
 
-	sarl	$1, %ecx
+	sarq	$1, %rcx
 	jz	L1.2
 
 	;;; Clear the direction flag to increment ESI/EDI
@@ -114,12 +114,12 @@
 	;;; otherwise return <false>
 
 	je	L1.2
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
-L1.2:	movl	$C_LAB(true), (%USP)
+L1.2:	movq	$C_LAB(true), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _ICMP:
 ;;; _CMP:
@@ -136,15 +136,15 @@
 DEF_C_LAB (_icmp)
 DEF_C_LAB (_cmp)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	movl	8(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	movq	16(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Convert ECX to size in longs; if zero, then return <true>
 	;;; immediately
 
-	sarl	$2, %ecx
+	sarq	$2, %rcx
 	jz	L1.3
 
 	;;; Clear the direction flag to increment ESI/EDI
@@ -160,12 +160,12 @@
 	;;; otherwise return <false>
 
 	je	L1.3
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
-L1.3:	movl	$C_LAB(true), (%USP)
+L1.3:	movq	$C_LAB(true), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === MOVES =========================================================
@@ -186,19 +186,19 @@
 
 DEF_C_LAB (_moveq)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	movl	8(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	movq	16(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Compare source and destination pointers and quit if the same
 
-	cmpl	%esi, %edi
+	cmpq	%rsi, %rdi
 	je	L2.1
 
 	;;; Convert the byte-length in ECX to longwords and quit if zero
 
-	sarl	$2, %ecx
+	sarq	$2, %rcx
 	jz	L1.4
 
 	;;; Do the move
@@ -209,17 +209,17 @@
 
 L1.4:	;;; Return the next destination address
 
-	movl	%edi, (%USP)
+	movq	%rdi, (%USP)
 	ret
 
 L2.1:	;;; Source and destination the same:
 	;;; compute and return the next destination address
 
-	addl	%ecx, %edi
-	movl	%edi, (%USP)
+	addq	%rcx, %rdi
+	movq	%rdi, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _BMOVE:
 ;;; _SMOVE:
@@ -240,21 +240,21 @@
 
 	;;; Set register arguments for -movchars-
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	movl	8(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	movq	16(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Push the next destination address as the return value
 
-	leal	(%edi, %ecx), %eax
-	movl	%eax, (%USP)
+	leaq	(%rdi, %rcx), %rax
+	movq	%rax, (%USP)
 
 	;;; Do the move
 
 	jmp	movchars
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_imove)
 DEF_C_LAB (_dmove)
@@ -262,21 +262,21 @@
 
 	;;; Set register arguments for movchars
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	movl	8(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	movq	16(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Push the next destination address as the return value
 
-	leal	(%edi, %ecx), %eax
-	movl	%eax, (%USP)
+	leaq	(%rdi, %rcx), %rax
+	movq	%rax, (%USP)
 
 	;;; Do the move in longword steps
 
 	jmp	movchars_l
 
-	.align	4
+	.align  16
 
 ;;; MOVCHARS:
 ;;; MOVCHARS_L:
@@ -301,14 +301,14 @@
 	;;; OR together the bits of the source address, destination address
 	;;; and byte count to test for word alignment
 
-	movl	%esi, %eax
-	orl	%edi, %eax
-	orl	%ecx, %eax
+	movq	%rsi, %rax
+	orq	%rdi, %rax
+	orq	%rcx, %rax
 
 	;;; If neither of the bottom two bits is set, the move is longword
 	;;; aligned so move a longword at a time
 
-	testl	$3, %eax
+	testq	$3, %rax
 	jz	movchars_l
 
 	;;; Otherwise, move a byte at a time
@@ -317,7 +317,7 @@
 
 	;;; If ECX is zero there's nothing to move, so exit
 
-	cmpl	$0, %ecx
+	cmpq	$0, %rcx
 	je	L2.2
 
 	;;; Clear the direction flag for a default downwards move
@@ -328,7 +328,7 @@
 	;;; if ESI > EDI, then the move is down, so jump straight to it;
 	;;; if ESI = EDI, then there's no move at all, so return
 
-	cmpl	%edi, %esi
+	cmpq	%rdi, %rsi
 	ja	L1.5
 	je	L2.2
 
@@ -337,8 +337,8 @@
 	;;; byte in each region rather than the first
 
 	std
-	leal	-1(%esi, %ecx), %esi
-	leal	-1(%edi, %ecx), %edi
+	leaq	-1(%rsi, %rcx), %rsi
+	leaq	-1(%rdi, %rcx), %rdi
 
 L1.5:	;;; Do the move
 
@@ -349,14 +349,14 @@
 
 	ret
 
-	.align	4
+	.align  16
 
 movchars_l:
 
 	;;; Convert ECX to the length of the move in longwords; if zero,
 	;;; jump to the end.
 
-	sarl	$2, %ecx
+	sarq	$2, %rcx
 	jz	L2.3
 
 	;;; Clear the direction flag for a default downwards move
@@ -367,7 +367,7 @@
 	;;; if ESI > EDI, then the move is down, so jump straight to it;
 	;;; if ESI = EDI, then there's no move at all, so return
 
-	cmpl	%edi, %esi
+	cmpq	%rdi, %rsi
 	ja	L1.6
 	je	L2.3
 
@@ -376,8 +376,8 @@
 	;;; word in each region rather than the first
 
 	std
-	leal	-4(%esi, %ecx, 4), %esi
-	leal	-4(%edi, %ecx, 4), %edi
+	leaq	-4(%rsi, %rcx, 4), %rsi
+	leaq	-4(%rdi, %rcx, 4), %rdi
 
 L1.6:	;;; Do the move
 
@@ -388,7 +388,7 @@
 
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === FILLING =======================================================
@@ -406,10 +406,10 @@
 
 DEF_C_LAB (_bfill)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %ecx
-	movl	8(%USP), %eax
-	addl	$12, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rcx
+	movq	16(%USP), %rax
+	addq	$24, %USP
 
 	;;; Clear the direction flag to increment EDI and do the fill
 
@@ -418,7 +418,7 @@
 	sstob
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _IFILL:
 ;;; _FILL:
@@ -433,23 +433,40 @@
 ;;;	EDI	destination pointer
 
 DEF_C_LAB (_ifill)
-DEF_C_LAB (_fill)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %ecx
-	movl	8(%USP), %eax
-	addl	$12, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rcx
+	movq	16(%USP), %rax
+	addq	$24, %USP
 
 	;;; Clear the direction flag to increment EDI, convert ECX to
 	;;; length in longwords and do the filling
 
 	cld
-	sarl	$2, %ecx
+	sarq	$2, %rcx
 	rep
 	sstol
 	ret
 
-	.align	4
+	.align  16
+
+DEF_C_LAB (_fill)
+
+        movq    (%USP), %rdi
+        movq    8(%USP), %rcx
+        movq    16(%USP), %rax
+        addq    $24, %USP
+
+        ;;; Clear the direction flag to increment EDI, convert ECX to
+        ;;; length in longwords and do the filling
+
+        cld
+        sarq    $3, %rcx
+        rep
+        sstoq
+        ret
+
+        .align  4
 
 
 ;;; === RELOCATING POPLOG MEMORY REGIONS ==============================
@@ -471,12 +488,12 @@
 
 	;;; Load the amount to shift (in bytes) into EAX
 
-	movl	(%USP), %eax
-	addl	$4, %USP
+	movq	(%USP), %rax
+	addq	$8, %USP
 
 	;;; Test the direction of the move
 
-	testl	%eax, %eax
+	testq	%rax, %rax
 	jl	move_userstack_down
 	jg	move_userstack_up
 
@@ -484,7 +501,7 @@
 
 	ret
 
-	.align	4
+	.align  16
 
 move_userstack_down:
 
@@ -492,27 +509,27 @@
 
 	;;; Adjust the value of USERHI
 
-	movl	I_LAB(_userhi), %ecx
-	addl	%eax, %ecx
-	movl	%ecx, I_LAB(_userhi)
+	movq	I_LAB(_userhi), %rcx
+	addq	%rax, %rcx
+	movq	%rcx, I_LAB(_userhi)
 
 	;;; Adjust the stack pointer and make the old value the source
 	;;; pointer and the new value the destination pointer
 
-	movl	%USP, %esi
-	addl	%eax, %USP
-	movl	%USP, %edi
+	movq	%USP, %rsi
+	addq	%rax, %USP
+	movq	%USP, %rdi
 
 	;;; Compute the length of the move (USERHI - USP) in ECX and do it
 
-	subl	%USP, %ecx
-	sarl	$2, %ecx
+	subq	%USP, %rcx
+	sarq	$3, %rcx
 	cld
 	rep
-	smovl
+	smovq
 	ret
 
-	.align	4
+	.align  16
 
 move_userstack_up:
 
@@ -522,26 +539,26 @@
 	;;; the destination pointer. Pointers are offset by 4 bytes because
 	;;; USERHI points one word beyond the top of stack.
 
-	movl	I_LAB(_userhi), %ecx
-	leal	-4(%ecx), %esi
-	addl	%eax, %ecx
-	leal	-4(%ecx), %edi
-	movl	%ecx, I_LAB(_userhi)
+	movq	I_LAB(_userhi), %rcx
+	leaq	-8(%rcx), %rsi
+	addq	%rax, %rcx
+	leaq	-8(%rcx), %rdi
+	movq	%rcx, I_LAB(_userhi)
 
 	;;; Adjust the stack pointer
 
-	addl	%eax, %USP
+	addq	%rax, %USP
 
 	;;; Compute the length of the move (USERHI - USP) in ECX and do it
 
-	subl	%USP, %ecx
-	sarl	$2, %ecx
+	subq	%USP, %rcx
+	sarq	$3, %rcx
 	std
 	rep
-	smovl
+	smovq
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _MOVE_CALLSTACK:
 ;;;	Relocate the top part of the callstack between the stack pointer
@@ -561,13 +578,13 @@
 
 	;;; Load limit address to ECX, byte offset to EAX
 
-	movl	(%USP), %ecx
-	movl	4(%USP), %eax
-	addl	$8, %USP
+	movq	(%USP), %rcx
+	movq	8(%USP), %rax
+	addq	$16, %USP
 
 	;;; Test the direction of the move
 
-	testl	%eax, %eax
+	testq	%rax, %rax
 	jl	move_callstack_down
 	jg	move_callstack_up
 
@@ -575,7 +592,7 @@
 
 	ret
 
-	.align	4
+	.align  16
 
 move_callstack_down:
 
@@ -583,24 +600,24 @@
 
 	;;; The length of the move is (_LIMIT - ESP)
 
-	subl	%esp, %ecx
+	subq	%rsp, %rcx
 
 	;;; Adjust the stack pointer and make the old value the source
 	;;; pointer and the new value the destination pointer
 
-	movl	%esp, %esi
-	addl	%eax, %esp
-	movl	%esp, %edi
+	movq	%rsp, %rsi
+	addq	%rax, %rsp
+	movq	%rsp, %rdi
 
 	;;; Do the move
 
-	sarl	$2, %ecx
+	sarq	$3, %rcx
 	cld
 	rep
-	smovl
+	smovq
 	ret
 
-	.align	4
+	.align  16
 
 move_callstack_up:
 
@@ -609,27 +626,27 @@
 	;;; Make _LIMIT the source address (offset by 4 to point to the
 	;;; first word to be moved) and (SOURCE + _BYTE_OFFS) the destination
 
-	leal	-4(%ecx), %esi
-	leal	(%esi, %eax), %edi
+	leaq	-8(%rcx), %rsi
+	leaq	(%rsi, %rax), %rdi
 
 	;;; The length of the move is (_LIMIT - ESP)
 
-	subl	%esp, %ecx
+	subq	%rsp, %rcx
 
 	;;; Do the move
 
-	sarl	$2, %ecx
+	sarq	$3, %rcx
 	std
 	rep
-	smovl
+	smovq
 
 	;;; Set the new stack pointer
 
-	leal	4(%edi), %esp
+	leaq	8(%rdi), %rsp
 
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === BITFIELD OPERATIONS ===========================================
@@ -652,71 +669,71 @@
 
 	;;; Copy bit offset to ECX
 
-	movl	%eax, %ecx
+	movq	%rax, %rcx
 
 	;;; Convert bit offset to word index
 
-	sarl	$5, %eax
+	sarq	$6, %rax
 
 	;;; Compute address of the first word of the bitfield in EDI.
 	;;; Load first word to EAX and second to EDI in case of overspill.
 
-	leal	(%edi, %eax, 4), %edi
-	movl	(%edi), %eax
-	movl	4(%edi), %edi
+	leaq	(%rdi, %rax, 8), %rdi
+	movq	(%rdi), %rax
+	movq	8(%rdi), %rdi
 
 	;;; Mask the copied offset in ECX to get a bit-within-word offset
 	;;; and shift EAX down by that amount to right-align the field
 	;;; (bits are pulled in to the top end from EDI)
 
-	andl	$31, %ecx
-	shrdl	%edi, %eax
+	andq	$63, %rcx
+	shrdq	%rdi, %rax
 
 	;;; Zero the top (32 - field-width) bits
 
-	movl	$32, %ecx
-	subl	%edx, %ecx
-	sall	%cl, %eax
-	shrl	%cl, %eax
+	movq	$64, %rcx
+	subq	%rdx, %rcx
+	salq	%cl, %rax
+	shrq	%cl, %rax
 
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB(_sbfield)
 
 	;;; Copy bit offset to ECX
 
-	movl	%eax, %ecx
+	movq	%rax, %rcx
 
 	;;; Convert bit offset to word index
 
-	sarl	$5, %eax
+	sarq	$6, %rax
 
 	;;; Compute address of the first word of the bitfield in EDI.
 	;;; Load first word to EAX and second to EDI in case of overspill.
 
-	leal	(%edi, %eax, 4), %edi
-	movl	(%edi), %eax
-	movl	4(%edi), %edi
+	leaq	(%rdi, %rax, 8), %rdi
+	movq	(%rdi), %rax
+	movq	8(%rdi), %rdi
 
 	;;; Mask the copied offset in ECX to get a bit-within-word offset
 	;;; and shift EAX down by that amount to right-align the field
 	;;; (bits are pulled in to the top end from EDI)
 
-	andl	$31, %ecx
-	shrdl	%edi, %eax
+	andq	$63, %rcx
+	shrdq	%rdi, %rax
 
 	;;; Sign-extend the field into the top (32 - field-width) bits
 
-	movl	$32, %ecx
-	subl	%edx, %ecx
-	sall	%cl, %eax
-	sarl	%cl, %eax
+	movq	$64, %rcx
+	subq	%rdx, %rcx
+	salq	%cl, %rax
+	sarq	%cl, %rax
 
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _UBFIELD:
 ;;;	Update a bitfield within a structure. Not called directly from POP
@@ -738,41 +755,41 @@
 
 DEF_C_LAB (_ubfield)
 
-	;;; Compute (32 - field-width) in ECX
+	;;; Compute (64 - field-width) in ECX
 
-	movl	$32, %ecx
-	subl	%edx, %ecx
+	movq	$64, %rcx
+	subq	%rdx, %rcx
 
 	;;; Copy the bit offset into EDX
 
-	movl	%eax, %edx
+	movq	%rax, %rdx
 
 	;;; Convert bit offset to word index and add to the structure
 	;;; address to get a pointer to the first word of the bitfield
 
-	sarl	$5, %eax
-	leal	(%edi, %eax, 4), %edi
+	sarq	$6, %rax
+	leaq	(%rdi, %rax, 8), %rdi
 
 	;;; Get the new value of the field from the stack top to EAX
 	;;; EAX = [ ___ | MMM' ]
 
-	movl	(%USP), %eax
-	addl	$4, %USP
+	movq	(%USP), %rax
+	addq	$8, %USP
 
 	;;; Shift left by (32 - field-width) to left-align it in EAX
 	;;; EAX = [ MMM' | ___ ]
 
-	shll	%cl, %eax
+	shlq	%cl, %rax
 
 	;;; Mask the copied bit offset in EDX to get a bit-within-word
 	;;; offset
 
-	andl	$31, %edx
+	andq	$63, %rdx
 
 	;;; Subtract from the value in ECX: this gives the number of unwanted
 	;;; bits in the high end of the first word
 
-	subl	%edx, %ecx
+	subq	%rdx, %rcx
 
 	;;; If negative, the field must overspill into a second word,
 	;;; so jump to handle that
@@ -782,68 +799,68 @@
 	;;; Otherwise, load the current value of the target word into ESI
 	;;; ESI = [ HHH | MMM | LLL ]
 
-	movl	(%edi), %esi
+	movq	(%rdi), %rsi
 
 	;;; Rotate to move the current field value to the top
 	;;; ESI = [ MMM | LLL | HHH ]
 
-	roll	%cl, %esi
+	rolq	%cl, %rsi
 
 	;;; Reinstate the shift count and pull the extra bits from ESI
 	;;; into the top of EAX
 	;;; EAX = [ LLL | HHH | MMM' ]
 
-	addl	%edx, %ecx
-	shrdl	%esi, %eax
+	addq	%rdx, %rcx
+	shrdq	%rsi, %rax
 
 	;;; Rotate the low order bits to their correct place
 	;;; EAX = [ HHH | MMM' | LLL ]
 
-	movl	%edx, %ecx
-	roll	%cl, %eax
+	movq	%rdx, %rcx
+	rolq	%cl, %rax
 
 	;;; Store the updated word and return
 
-	movl	%eax, (%edi)
+	movq	%rax, (%rdi)
 	ret
 
 L1.7:	;;; Field overspills into a second word -- load that first
 	;;; ESI = [ HHH | MMH ]
 
-	movl	4(%edi), %esi
+	movq	8(%rdi), %rsi
 
 	;;; The size of the overspill is the absolute value of ECX;
 	;;; shift ESI by that amount, then pull in the top bits of the
 	;;; new value. Drop the corresponding bits from EAX.
 
-	negl	%ecx
-	shrl	%cl, %esi		;;; ESI = [ 000 | HHH ]
-	shldl	%eax, %esi		;;; ESI = [ HHH | MMH' ]
-	shll	%cl, %eax		;;; EAX = [ MML' | 000 ]
+	negq	%rcx
+	shrq	%cl, %rsi		;;; ESI = [ 000 | HHH ]
+	shldq	%rax, %rsi		;;; ESI = [ HHH | MMH' ]
+	shlq	%cl, %rax		;;; EAX = [ MML' | 000 ]
 
 	;;; Store the updated high word
 
-	movl	%esi, 4(%edi)
+	movq	%rsi, 8(%rdi)
 
 	;;; Now get the low word
 	;;; ESI = [ MML | LLL ]
 
-	movl	(%edi), %esi
+	movq	(%rdi), %rsi
 
 	;;; Only the bottom bits of this are wanted, the count being in
 	;;; EDX. Shift them into the high part of EAX, then rotate to
 	;;; place them in the low part
 
-	movl	%edx, %ecx
-	shrdl	%esi, %eax		;;; EAX = [ LLL | MML' ]
-	roll	%cl, %eax		;;; EAX = [ MML' | LLL ]
+	movq	%rdx, %rcx
+	shrdq	%rsi, %rax		;;; EAX = [ LLL | MML' ]
+	rolq	%cl, %rax		;;; EAX = [ MML' | LLL ]
 
 	;;; Store the low word and return
 
-	movl	%eax, (%edi)
+	movq	%rax, (%rdi)
 	ret
 
-	.align	4
+	.align  16
 
 
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/aprocess.s v15.6301-amd64/pop/src/aprocess.s
--- v15.63/pop/src/aprocess.s	1996-08-09 13:16:33.000000000 -0400
+++ v15.6301-amd64/pop/src/aprocess.s	2009-12-24 15:36:33.000000000 -0500
@@ -12,9 +12,9 @@
 
 lconstant macro (
 
-	USP			= "ebx",
-	PB			= "ebp",
-	CHAIN_REG		= "edx",
+	USP			= "rbx",
+	PB			= "rbp",
+	CHAIN_REG		= "rdx",
 
 	_ID_VALOF		= @@ID_VALOF,
 	_PD_EXECUTE		= @@PD_EXECUTE,
@@ -31,6 +31,11 @@
 	_PS_STATE		= @@PS_STATE,
 );
 
+lconstant macro MOVFL   = if DEF FRAME_LEN_16BIT then "movzwl"
+                          elseif DEF FRAME_LEN_32BIT then "movl"
+                          else "movzbl"
+                          endif;
+
 >_#
 
 	.file	"aprocess.s"
@@ -38,10 +43,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -52,15 +57,15 @@
 	.data
 
 PROCESS:		;;; Process record
-	.long	0
+	.quad	0
 LIMIT:			;;; Limit of the callstack save area
-	.long	0
+	.quad	0
 NEXT_FRAME:		;;; Pointer to the next frame in the saved callstack
-	.long	0
+	.quad	0
 
 	.text
 
-.set	BRANCH_std, 7 	;;; Size of a standard branch instruction
+.set	BRANCH_std, 9 	;;; Size of a standard branch instruction
 			;;; (as placed by I_BRANCH_std)
 
 ;;; _SWAP_OUT_CALLSTACK:
@@ -72,13 +77,13 @@
 
 DEF_C_LAB (_swap_out_callstack)
 
-	movl	(%USP), %eax
-	addl	$4, %USP
+	movq	(%USP), %rax
+	addq	$8, %USP
 
-	movl	%eax, PROCESS			;;; Save the process record
-	movl	_PS_CALLSTACK_LIM(%eax), %edi	;;; Start of saved callstack
-	movl	_PS_STATE(%eax), %eax
-	movl	%eax, LIMIT			;;; End of saved callstack
+	movq	%rax, PROCESS			;;; Save the process record
+	movq	_PS_CALLSTACK_LIM(%rax), %rdi	;;; Start of saved callstack
+	movq	_PS_STATE(%rax), %rax
+	movq	%rax, LIMIT			;;; End of saved callstack
 	jmp	sotest
 
 soloop:
@@ -87,12 +92,12 @@
 	;;; save the return address in ECX, then set the procedure base
 	;;; register from the owner address on the stack top
 
-	popl	%ecx
-	movl	(%esp), %PB
+	popq	%rcx
+	movq	(%rsp), %PB
 
 	;;; Make the return address relative to the procedure base
 
-	subl	%PB, %ecx
+	subq	%PB, %rcx
 
 	;;; Test if the procedure has dlocal expression code to run
 
@@ -107,31 +112,31 @@
 	;;; record; we compute the position of the next frame by subtracting
 	;;; the length of the current stack frame
 
-	movzbl	_PD_FRAME_LEN(%PB), %eax
-	sall	$2, %eax
-	subl	%eax, %edi
-	movl	%edi, NEXT_FRAME
+	MOVFL	_PD_FRAME_LEN(%PB), %eax
+	salq	$3, %rax
+	subq	%rax, %rdi
+	movq	%rdi, NEXT_FRAME
 
 	;;; Save relative return address and owner address in the process
 	;;; record
 
-	movl	%ecx, (%edi)
-	movl	%PB, 4(%edi)
-	addl	$8, %edi
+	movq	%rcx, (%rdi)
+	movq	%PB, 8(%rdi)
+	addq	$16, %rdi
 
 	;;; Copy any on-stack lvars into the process record
 
 	cld
-	movzbl	_PD_NUM_STK_VARS(%PB), %ecx
-	leal	4(%esp), %esi
+	MOVFL	_PD_NUM_STK_VARS(%PB), %ecx
+	leaq	8(%rsp), %rsi
 	rep
-	smovl
-	movl	%esi, %esp
+	smovq
+	movq	%rsi, %rsp
 
 	;;; Test if there are any dynamic locals
 
-	movzbl	_PD_NLOCALS(%PB), %ecx
-	cmpl	$0, %ecx
+	MOVFL	_PD_NLOCALS(%PB), %ecx
+	cmpq	$0, %rcx
 	je	L2.1
 
 	;;; If so, copy the current values of the locals into the
@@ -140,38 +145,38 @@
 	;;; ESI is initialised to point to the last entry in the procedure's
 	;;; identifier table
 
-	leal	_PD_TABLE-4(%PB, %ecx, 4), %esi
+	leaq	_PD_TABLE-8(%PB, %rcx, 8), %rsi
 
 L1.1:				;;; Loop:
-	movl	(%esi), %edx	;;; ident to EDX
-	movl	_ID_VALOF(%edx), %eax	;;; idval to EAX
-	sstol			;;; save idval in process record
-	popl	_ID_VALOF(%edx)	;;; restore previous idval from stack
-	subl    $4, %esi	;;; decrement ESI
+	movq	(%rsi), %rdx	;;; ident to EDX
+	movq	_ID_VALOF(%rdx), %rax	;;; idval to EAX
+	sstoq			;;; save idval in process record
+	popq	_ID_VALOF(%rdx)	;;; restore previous idval from stack
+	subq    $8, %rsi	;;; decrement ESI
 	loop	L1.1
 
 L2.1:	;;; Stack frame saved -- restore EDI to point to where the next
 	;;; should go
 
-	movl	NEXT_FRAME, %edi
+	movq	NEXT_FRAME, %rdi
 
 sotest:
 
 	;;; Test if there are any more stack frames to swap out
 
-	cmpl	%edi, LIMIT
+	cmpq	%rdi, LIMIT
 	jb	soloop
 
 sodone:
 
 	;;; Finished swapping out -- chain procedure on stack
 
-	movl	PROCESS, %eax
-	movl	$0, _PS_CALLSTACK_PARTIAL(%eax)
-	movw	$0, _PS_FLAGS(%eax)		;;; 0 flags = suspended
-	movl	(%USP), %eax
-	addl	$4, %USP
-	jmp	*_PD_EXECUTE(%eax)		;;; chain procedure
+	movq	PROCESS, %rax
+	movq	$0, _PS_CALLSTACK_PARTIAL(%rax)
+	movw	$0, _PS_FLAGS(%rax)		;;; 0 flags = suspended
+	movq	(%USP), %rax
+	addq	$8, %USP
+	jmp	*_PD_EXECUTE(%rax)		;;; chain procedure
 
 sobrk:
 
@@ -179,46 +184,46 @@
 	;;; appropriate part of the exit code of the procedure.
 	;;; The process is passed in CHAIN_REG
 
-	movl	PROCESS, %CHAIN_REG
+	movq	PROCESS, %CHAIN_REG
 
 	;;; Save relative return address and callstack save pointer in the
 	;;; process record
 
-	movl	%ecx, _PS_PARTIAL_RETURN(%CHAIN_REG)
-	movl	%edi, _PS_CALLSTACK_PARTIAL(%CHAIN_REG)
+	movq	%rcx, _PS_PARTIAL_RETURN(%CHAIN_REG)
+	movq	%rdi, _PS_CALLSTACK_PARTIAL(%CHAIN_REG)
 
 	;;; Go to the procedure's suspend code
 
-	movl	_PD_EXIT(%PB), %eax
-	subl	$BRANCH_std << 1, %eax
-	jmp	*%eax
+	movq	_PD_EXIT(%PB), %rax
+	subq	$BRANCH_std << 1, %rax
+	jmp	*%rax
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_swap_out_continue)
 
 	;;; The suspend code returns here to resume the swapout loop
 	;;; The process will still be in CHAIN_REG
 
-	movl	%CHAIN_REG, PROCESS
+	movq	%CHAIN_REG, PROCESS
 
 	;;; Restore callstack save pointer, relative return address and
 	;;; save limit from the process record
 
-	movl	_PS_CALLSTACK_PARTIAL(%CHAIN_REG), %edi
-	movl	_PS_PARTIAL_RETURN(%CHAIN_REG), %ecx
-	movl	_PS_STATE(%CHAIN_REG), %eax
-	movl	%eax, LIMIT
+	movq	_PS_CALLSTACK_PARTIAL(%CHAIN_REG), %rdi
+	movq	_PS_PARTIAL_RETURN(%CHAIN_REG), %rcx
+	movq	_PS_STATE(%CHAIN_REG), %rax
+	movq	%rax, LIMIT
 
 	;;; Restore procedure base from the stack top
 
-	movl	(%esp), %PB
+	movq	(%rsp), %PB
 
 	;;; Continue the swapout loop
 
 	jmp	socont
 
-	.align	4
+	.align  16
 
 
 ;;; _SWAP_IN_CALLSTACK:
@@ -230,17 +235,17 @@
 
 DEF_C_LAB (_swap_in_callstack)
 
-	movl	(%USP), %eax
-	addl	$4, %USP
+	movq	(%USP), %rax
+	addq	$8, %USP
 
-	movl	%eax, PROCESS		;;; Save the process record
+	movq	%rax, PROCESS		;;; Save the process record
 
 	;;; Get a pointer to the start of the saved callstack in ESI
 	;;; and the limit in LIMIT
 
-	movl	_PS_STATE(%eax), %esi
-	movl	_PS_CALLSTACK_LIM(%eax), %eax
-	movl	%eax, LIMIT
+	movq	_PS_STATE(%rax), %rsi
+	movq	_PS_CALLSTACK_LIM(%rax), %rax
+	movq	%rax, LIMIT
 	jmp	sitest
 
 siloop:
@@ -248,21 +253,21 @@
 	;;; ESI points to the saved stack frame in the process record.
 	;;; Restore the procedure base register from the saved owner address.
 
-	movl	4(%esi), %PB
+	movq	8(%rsi), %PB
 
 	;;; Compute the position of the next frame in the record by adding
 	;;; the length of the current frame
 
-	movzbl	_PD_FRAME_LEN(%PB), %eax
-	leal	(%esi, %eax, 4), %esi
-	movl	%esi, NEXT_FRAME
-	subl	$4, %esi
+	MOVFL	_PD_FRAME_LEN(%PB), %eax
+	leaq	(%rsi, %rax, 8), %rsi
+	movq	%rsi, NEXT_FRAME
+	subq	$8, %rsi
 
 	;;; Check for any dynamic locals
 
 	std
-	movzbl	_PD_NLOCALS(%PB), %ecx
-	cmpl	$0, %ecx
+	MOVFL	_PD_NLOCALS(%PB), %ecx
+	cmpq	$0, %rcx
 	je	L2.2
 
 	;;; If so, push the current values of the locals on the stack
@@ -270,37 +275,37 @@
 	;;; EDI is initialised to point to the first entry in the procedure's
 	;;; identifier table
 
-	leal	_PD_TABLE(%PB), %edi
+	leaq	_PD_TABLE(%PB), %rdi
 
 L1.2:				;;; Loop:
-	movl	(%edi), %edx	;;; ident to EDX
-	pushl	_ID_VALOF(%edx)	;;; push the idval
-	slodl			;;; new idval from process record to EAX
-	movl	%eax, _ID_VALOF(%edx)	;;; set new idval
-	addl	$4, %edi	;;; increment EDI
+	movq	(%rdi), %rdx	;;; ident to EDX
+	pushq	_ID_VALOF(%rdx)	;;; push the idval
+	slodq			;;; new idval from process record to EAX
+	movq	%rax, _ID_VALOF(%rdx)	;;; set new idval
+	addq	$8, %rdi	;;; increment EDI
 	loop	L1.2
 
 L2.2:	;;; Copy any on-stack lvars from the saved frame,
 	;;; adjusting ESP first in case of interrupts
 
-	movzbl	_PD_NUM_STK_VARS(%PB), %ecx
-	leal	-4(%esp), %edi
+	MOVFL	_PD_NUM_STK_VARS(%PB), %ecx
+	leaq	-8(%rsp), %rdi
 
-	leal	(, %ecx, 4), %eax
-	subl	%eax, %esp
+	leaq	(, %rcx, 8), %rax
+	subq	%rax, %rsp
 
 	rep
-	smovl
+	smovq
 
 	;;; Push the owner address from the procedure base register
 	;;; and set ECX to be the saved relative return address
 
-	pushl	%PB
-	movl	-4(%esi), %ecx
+	pushq	%PB
+	movq	-8(%rsi), %rcx
 
 	;;; Set ESI to point to the next frame
 
-	movl	NEXT_FRAME, %esi
+	movq	NEXT_FRAME, %rsi
 
 	;;; Test for dlocal expression code to run
 
@@ -313,25 +318,25 @@
 
 	;;; Make the relative return address in ECX absolute and push it
 
-	addl	%PB, %ecx
-	pushl	%ecx
+	addq	%PB, %rcx
+	pushq	%rcx
 
 sitest:
 
 	;;; Test if there are more frames to swap in
 
-	cmpl	%esi, LIMIT
+	cmpq	%rsi, LIMIT
 	ja	siloop
 
 sidone:
 
 	;;; Finished swapping in - chain procedure from stack
 
-	movl	PROCESS, %eax
-	movl	$0, _PS_CALLSTACK_PARTIAL(%eax)
-	movl	(%USP), %eax
-	addl	$4, %USP
-	jmp	*_PD_EXECUTE(%eax)		;;; chain procedure
+	movq	PROCESS, %rax
+	movq	$0, _PS_CALLSTACK_PARTIAL(%rax)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	jmp	*_PD_EXECUTE(%rax)		;;; chain procedure
 
 sibrk:
 
@@ -339,46 +344,46 @@
 	;;; appropriate part of the exit code of the procedure.
 	;;; The process is passed in CHAIN_REG
 
-	movl	PROCESS, %CHAIN_REG
+	movq	PROCESS, %CHAIN_REG
 
 	;;; Save relative return address and callstack save pointer in the
 	;;; process record
 
-	movl	%ecx, _PS_PARTIAL_RETURN(%CHAIN_REG)
-	movl	%esi, _PS_CALLSTACK_PARTIAL(%CHAIN_REG)
+	movq	%rcx, _PS_PARTIAL_RETURN(%CHAIN_REG)
+	movq	%rsi, _PS_CALLSTACK_PARTIAL(%CHAIN_REG)
 
 	;;; Go to the procedure's resume code
 
-	movl	_PD_EXIT(%PB), %eax
-	subl	$BRANCH_std, %eax
-	jmp	*%eax
+	movq	_PD_EXIT(%PB), %rax
+	subq	$BRANCH_std, %rax
+	jmp	*%rax
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_swap_in_continue)
 
 	;;; The resume code returns here to continue the swapin loop
 	;;; The process will still be in CHAIN_REG
 
-	movl	%CHAIN_REG, PROCESS
+	movq	%CHAIN_REG, PROCESS
 
 	;;; Restore callstack save pointer, relative return address and
 	;;; save limit from the process record
 
-	movl	_PS_CALLSTACK_PARTIAL(%CHAIN_REG), %esi
-	movl	_PS_PARTIAL_RETURN(%CHAIN_REG), %ecx
-	movl	_PS_CALLSTACK_LIM(%CHAIN_REG), %eax
-	movl	%eax, LIMIT
+	movq	_PS_CALLSTACK_PARTIAL(%CHAIN_REG), %rsi
+	movq	_PS_PARTIAL_RETURN(%CHAIN_REG), %rcx
+	movq	_PS_CALLSTACK_LIM(%CHAIN_REG), %rax
+	movq	%rax, LIMIT
 
 	;;; Restore the procedure base from the stack top
 
-	movl	(%esp), %PB
+	movq	(%rsp), %PB
 
 	;;; Continue the swapin loop
 
 	jmp	sicont
 
-	.align	4
+	.align  16
 
 
 ;;; === SWAPPING THE USERSTACK ========================================
@@ -391,43 +396,43 @@
 
 DEF_C_LAB (_ussave)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rcx
+	addq	$16, %USP
 	std
 
 	;;; Make ESI point to the first word on the stack,
 	;;; and EDI point to the end of the save area
 
-	movl	I_LAB(_userhi), %esi
-	subl	$4, %esi
-	movl	%esi, %edx			;;; Save for later
-	leal	-4(%edi, %ecx), %edi
+	movq	I_LAB(_userhi), %rsi
+	subq	$8, %rsi
+	movq	%rsi, %rdx			;;; Save for later
+	leaq	-8(%rdi, %rcx), %rdi
 
 	;;; Do the save
 
-	sarl	$2, %ecx
+	sarq	$3, %rcx
 	rep
-	smovl
+	smovq
 
 	;;; Make EDI point to the stack end
 
-	movl	%edx, %edi
+	movq	%rdx, %rdi
 
 	;;; Compute the amount of stack left and shift it up
 
-	leal	4(%esi), %ecx
-	subl	%USP, %ecx
-	sarl	$2, %ecx
+	leaq	8(%rsi), %rcx
+	subq	%USP, %rcx
+	sarq	$3, %rcx
 	rep
-	smovl
+	smovq
 
 	;;; Set the stack pointer and return
 
-	leal	4(%edi), %USP
+	leaq	8(%rdi), %USP
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _USRESTORE:
 ;;;	Restore a number of bytes at the end of the user stack
@@ -437,35 +442,35 @@
 
 DEF_C_LAB (_usrestore)
 
-	movl	(%USP), %eax
-	movl	4(%USP), %edx
-	addl	$8, %USP
+	movq	(%USP), %rax
+	movq	8(%USP), %rdx
+	addq	$16, %USP
 	cld
 
 	;;; Shift existing stack down, leaving room for restored stuff
 
-	movl	I_LAB(_userhi), %ecx
-	subl	%USP, %ecx
-	sarl	$2, %ecx	;;; Length of existing stack in words
-	movl	%USP, %esi	;;; Source address is current USP
-	subl	%edx, %USP	;;; New USP ...
-	movl	%USP, %edi	;;; ... becomes destination address
+	movq	I_LAB(_userhi), %rcx
+	subq	%USP, %rcx
+	sarq	$3, %rcx	;;; Length of existing stack in words
+	movq	%USP, %rsi	;;; Source address is current USP
+	subq	%rdx, %USP	;;; New USP ...
+	movq	%USP, %rdi	;;; ... becomes destination address
 	rep
-	smovl
+	smovq
 
 	;;; Now copy the new stuff in
 
-	movl	%eax, %esi	;;; Source of new stuff
-	movl	I_LAB(_userhi), %edi
-	subl	%edx, %edi	;;; Destination
-	movl	%edx, %ecx
-	sarl	$2, %ecx	;;; Length in words
+	movq	%rax, %rsi	;;; Source of new stuff
+	movq	I_LAB(_userhi), %rdi
+	subq	%rdx, %rdi	;;; Destination
+	movq	%rdx, %rcx
+	sarq	$3, %rcx	;;; Length in words
 	rep
-	smovl
+	smovq
 
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _USERASUND:
 ;;;	Erase a number of bytes from the end of the user stack
@@ -475,22 +480,22 @@
 
 DEF_C_LAB (_userasund)
 
-	movl	(%USP), %eax	;;; Load length to erase to EAX
-	addl	$4, %USP
-	movl	I_LAB(_userhi), %ecx
-	leal	-4(%ecx), %edi	;;; Destination is first word on the stack
-	addl	%eax, %USP	;;; New stack pointer
-	subl	%USP, %ecx	;;; New stack length (= length of move)
+	movq	(%USP), %rax	;;; Load length to erase to EAX
+	addq	$8, %USP
+	movq	I_LAB(_userhi), %rcx
+	leaq	-8(%rcx), %rdi	;;; Destination is first word on the stack
+	addq	%rax, %USP	;;; New stack pointer
+	subq	%USP, %rcx	;;; New stack length (= length of move)
 	jz	L1.3		;;; If zero, nothing to do
-	movl	%edi, %esi	;;; Source is destination ...
-	subl	%eax, %esi	;;; ... offset by the amount being erased
-	sarl	$2, %ecx	;;; Length of move in words
+	movq	%rdi, %rsi	;;; Source is destination ...
+	subq	%rax, %rsi	;;; ... offset by the amount being erased
+	sarq	$3, %rcx	;;; Length of move in words
 	std
 	rep
-	smovl
+	smovq
 L1.3:	ret
 
-	.align	4
+	.align  16
 
 
 /***************** end labels for wrapping structures *****************/
